shinyServer(function(input, output, session) {
	
	output$datasets <- renderUI({
		print("datasets function")
		dataset.names <- GetDatasetnames()
		dataset.names <- namel(dataset.names)
		selectInput("dataset", "Dataset : ", dataset.names)
	})
	
	output$features <- renderUI({
		dataset.name <- input$dataset
		if(is.null(dataset.name) == TRUE) {
			return()
		}
		dataset.id <- GetDatasetId(dataset.name)
		feat.indices <- GetFeatureIndices(dataset.id)
		feat.vec <- GetFeatureNames(feat.indices, dataset.id)
		var.obj <- namel(feat.vec)
		selectInput("variable", "Features : ", var.obj, selected = '', multiple = TRUE)
	})
	
	output$featuresetname <- renderUI({
		textInput("featsetname", "Feature set name", "")
		
	})
	
	output$eval_cv_numfoldstext <- renderUI({
    		textInput("eval_cv_numfolds", "Num folds :", "")
	})
	
	output$createfsmsgout <- renderText({
		dataset.name <- isolate(input$dataset)
		feat.set.name <- isolate(input$featsetname)
		features <- isolate(input$variable)

		if(is.null(input$createfs) || input$createfs == 0)
			return()
		if(is.null(dataset.name))
			return()

		if(nchar(feat.set.name) == 0)
			return("Feature set name cannot be empty")
		
		if(length(features) == 0)
			return("Number of features selected cannot be 0")

		# features is a character vector
		dataset.id <- GetDatasetId(dataset.name)
		res.set <- AssignFeatureSet(features, dataset.id)
		
		UpdateFeaturesetName(feat.set.name, res.set)
		
		ret.str <- paste0("Feature set ", feat.set.name, " created with features : { ",
paste(features, collapse=","), " } ")	
		updateRadioButtons(session, "optype", "Operation Type :",
				c("Create Feature set" = "create",
				  "Execute Operation" = "execute",
				  "View Program" = "viewpgm",
				  "None" = "none"
    				  ), selected = "None"
		)
		return(ret.str)
		
		
	})
#-------------------------- avail feat set names ------------- start #	
	output$availfeatsetnames <- renderUI({
		if(input$optype == "create")
			return()
		feat.set.names <- GetFeaturesetNames()
		if(length(feat.set.names) == 0) {
			return("Create feature set first")
		}
			
		
		var.obj <- namel(feat.set.names)
		
		selectInput("selectedfeatset", "Available Featuresets : ", var.obj, selected = '', multiple = FALSE)
		
	})


	output$availfeatsetnames_corry <- renderUI({
		if(input$optype == "create")
			return()
		feat.set.names <- GetFeaturesetNames()
		if(length(feat.set.names) == 0) {
			return("Create feature set first")
		}
			
		
		var.obj <- namel(feat.set.names)
		
    		selectInput("selectedfeatset_corry", "Available Featuresets : ", var.obj, selected = '', multiple = FALSE)
		
	})


	output$availfeatsetnames_coefflearn <- renderUI({
		if(input$optype == "create")
			return()
		feat.set.names <- GetFeaturesetNames()
		if(length(feat.set.names) == 0) {
			return("Create feature set first")
		}
			
		
		var.obj <- namel(feat.set.names)
		
    		selectInput("selectedfeatset_coefflearn", "Available Featuresets : ", var.obj, selected = '', multiple = FALSE)
		
	})

	output$availfeatsetnames_eval_cv <- renderUI({
		if(input$optype == "create")
			return()
		feat.set.names <- GetFeaturesetNames()
		if(length(feat.set.names) == 0) {
			return("Create feature set first")
		}
			
		
		var.obj <- namel(feat.set.names)
		
    		selectInput("selectedfeatset_eval_cv", "Available Featuresets : ", var.obj, selected = '', multiple = FALSE)
		
	})



	output$availfeatsetnames_eval_aic <- renderUI({
		if(input$optype == "create")
			return()
		feat.set.names <- GetFeaturesetNames()
		if(length(feat.set.names) == 0) {
			return("Create feature set first")
		}
			
		
		var.obj <- namel(feat.set.names)
		
    		selectInput("selectedfeatset_eval_aic", "Available Featuresets : ", var.obj, selected = '', multiple = FALSE)
	})

	
	output$availfeatsetnames_stepadd_inp <- renderUI({
		if(input$optype == "create")
			return()
		feat.set.names <- GetFeaturesetNames()
		if(length(feat.set.names) == 0) {
			return("Create feature set first")
		}
			
		
		var.obj <- namel(feat.set.names)
		
    		selectInput("selectedfeatset_stepadd_inp", "Input Featuresets : ", var.obj, selected = '', multiple = FALSE)
	})

	output$availfeatsetnames_stepadd_mask <- renderUI({
		if(input$optype == "create")
			return()
		feat.set.names <- GetFeaturesetNames()
		if(length(feat.set.names) <= 0 ) {
			return("Create sufficient feature sets first")
		}
			
		
		var.obj <- namel(feat.set.names)
		
    		selectInput("selectedfeatset_stepadd_mask", "Mask Featuresets : ", var.obj, selected = '', multiple = FALSE)
	})
	
	output$availfeatsetnames_stepdrop_inp <- renderUI({
		if(input$optype == "create")
			return()
		feat.set.names <- GetFeaturesetNames()
		if(length(feat.set.names) == 0) {
			return("Create feature set first")
		}
			
		
		var.obj <- namel(feat.set.names)
		
    		selectInput("selectedfeatset_stepdrop_inp", "Input Featuresets : ", var.obj, selected = '', multiple = FALSE)
	})

#-------------------------- avail feat set names ------------- end #	

#-------------------------- view feature sets ------------- start #	
	output$viewfeaturesets <- renderText({
		if(is.null(input$viewfs) || input$viewfs == 0)
			return()
		dataset.name <- isolate(input$dataset)
		if(is.null(dataset.name))
			return()
		dataset.id <- GetDatasetId(dataset.name)
		feat.set.name <- isolate(input$selectedfeatset)
		
		res.set <- GetFeaturesetFromName(feat.set.name)
		feat.id <- res.set$feat.id
		set.val <- unlist(GetFeatureSet(feat.id))
		feature.names <- GetFeatureNames(set.val, dataset.id)
		ret.str <- paste0("Feature set ", feat.set.name, " created with features : { ",
paste(feature.names, collapse=","), " } ")
		return(ret.str)
		
	})


	output$viewfeaturesets_corry <- renderText({
		if(is.null(input$viewfscorry) || input$viewfscorry == 0)
			return()
		dataset.name <- isolate(input$dataset)
		if(is.null(dataset.name))
			return()
		dataset.id <- GetDatasetId(dataset.name)
		feat.set.name <- isolate(input$selectedfeatset_corry)
		
		res.set <- GetFeaturesetFromName(feat.set.name)
		feat.id <- res.set$feat.id
		set.val <- unlist(GetFeatureSet(feat.id))
		feature.names <- GetFeatureNames(set.val, dataset.id)
		ret.str <- paste0("Feature set ", feat.set.name, " created with features : { ",
paste(feature.names, collapse=","), " } ")
		#ret.ui <- wellPanel( h4(textOutput(ret.str)))
			
		return(ret.str)
		
	})
	
	output$viewfeaturesets_coefflearn <- renderText({
		if(is.null(input$viewfscoefflearn) || input$viewfscoefflearn == 0)
			return()
		dataset.name <- isolate(input$dataset)
		if(is.null(dataset.name))
			return()
		dataset.id <- GetDatasetId(dataset.name)
		feat.set.name <- isolate(input$selectedfeatset_coefflearn)
		
		res.set <- GetFeaturesetFromName(feat.set.name)
		feat.id <- res.set$feat.id
		set.val <- unlist(GetFeatureSet(feat.id))
		feature.names <- GetFeatureNames(set.val, dataset.id)
		ret.str <- paste0("Feature set ", feat.set.name, " created with features : { ",
paste(feature.names, collapse=","), " } ")
		#ret.ui <- wellPanel( h4(textOutput(ret.str)))
			
		return(ret.str)
		
	})
					
	output$viewfeaturesets_evalcv <- renderText({
		if(is.null(input$viewfsevalcv) || input$viewfsevalcv == 0)
			return()
		dataset.name <- isolate(input$dataset)
		if(is.null(dataset.name))
			return()
		dataset.id <- GetDatasetId(dataset.name)
		feat.set.name <- isolate(input$selectedfeatset_eval_cv)
		
		res.set <- GetFeaturesetFromName(feat.set.name)
		feat.id <- res.set$feat.id
		set.val <- unlist(GetFeatureSet(feat.id))
		feature.names <- GetFeatureNames(set.val, dataset.id)
		ret.str <- paste0("Feature set ", feat.set.name, " created with features : { ",
paste(feature.names, collapse=","), " } ")
		return(ret.str)
	})
	
	output$viewfeaturesets_evalaic <- renderText({
		if(is.null(input$viewfsevalaic) || input$viewfsevalaic == 0)
			return()
		dataset.name <- isolate(input$dataset)
		if(is.null(dataset.name))
			return()
		dataset.id <- GetDatasetId(dataset.name)
		feat.set.name <- isolate(input$selectedfeatset_eval_aic)
		
		res.set <- GetFeaturesetFromName(feat.set.name)
		feat.id <- res.set$feat.id
		set.val <- unlist(GetFeatureSet(feat.id))
		feature.names <- GetFeatureNames(set.val, dataset.id)
		ret.str <- paste0("Feature set ", feat.set.name, " created with features : { ",
paste(feature.names, collapse=","), " } ")
		return(ret.str)
	})


	output$viewfeaturesets_stepadd_inpset <- renderText({
		if(is.null(input$viewfs_stepadd_inpset) || input$viewfs_stepadd_inpset == 0)
			return()
		dataset.name <- isolate(input$dataset)
		if(is.null(dataset.name))
			return()
		dataset.id <- GetDatasetId(dataset.name)
		feat.set.name <- isolate(input$selectedfeatset_stepadd_inp)
		
		res.set <- GetFeaturesetFromName(feat.set.name)
		feat.id <- res.set$feat.id
		set.val <- unlist(GetFeatureSet(feat.id))
		feature.names <- GetFeatureNames(set.val, dataset.id)
		ret.str <- paste0("Inp.Feature set ", feat.set.name, " created with features : { ",
paste(feature.names, collapse=","), " } ")
		return(ret.str)
	})

	output$viewfeaturesets_stepadd_maskset <- renderText({
		if(is.null(input$viewfs_stepadd_maskset) || input$viewfs_stepadd_maskset == 0)
			return()
		dataset.name <- isolate(input$dataset)
		if(is.null(dataset.name))
			return()
		dataset.id <- GetDatasetId(dataset.name)
		feat.set.name <- isolate(input$selectedfeatset_stepadd_mask)
		
		res.set <- GetFeaturesetFromName(feat.set.name)
		feat.id <- res.set$feat.id
		set.val <- unlist(GetFeatureSet(feat.id))
		feature.names <- GetFeatureNames(set.val, dataset.id)
		ret.str <- paste0("Mask.Feature set ", feat.set.name, " created with features : { ",
paste(feature.names, collapse=","), " } ")
		return(ret.str)
	})

	output$viewfeaturesets_stepdrop_inpset <- renderText({
		if(is.null(input$viewfs_stepdrop_inpset) || input$viewfs_stepdrop_inpset == 0)
			return()
		dataset.name <- isolate(input$dataset)
		if(is.null(dataset.name))
			return()
		dataset.id <- GetDatasetId(dataset.name)
		feat.set.name <- isolate(input$selectedfeatset_stepdrop_inp)
		
		res.set <- GetFeaturesetFromName(feat.set.name)
		feat.id <- res.set$feat.id
		set.val <- unlist(GetFeatureSet(feat.id))
		feature.names <- GetFeatureNames(set.val, dataset.id)
		ret.str <- paste0("Inp.Feature set ", feat.set.name, " created with features : { ",
paste(feature.names, collapse=","), " } ")
		return(ret.str)
	})
#-------------------------- view feature sets ------------- end #	
	output$corrxresult <- renderChart({
		if(is.null(input$execorrx) || input$execorrx == 0)
			return()
		dataset.name <- isolate(input$dataset)
		dataset.id <- GetDatasetId(dataset.name)
		feat.set.name <- isolate(input$selectedfeatset)
		
		if(nchar(feat.set.name) == 0)
			return()
		res.set <- GetFeaturesetFromName(feat.set.name)
		InitStats()
		res.list <- CorrelationX(res.set, dataset.id)
		res.df <- CorrxResult(res.list, dataset.id)
		p1 <- nPlot(CorrValue ~ Feature1, group = "Feature1", data = res.df, type = 'scatterChart')
		p1$xAxis(axisLabel = 'Feature Index')
		#p1$x2Axis(axisLabel = 'Feature Y')
		p1$addParams(dom = "corrxresult")
		return(p1)
		
	})

	output$corryresult <- renderChart({
		if(is.null(input$execorry) || input$execorry == 0)
			return()
		
		dataset.name <- isolate(input$dataset)
		dataset.id <- GetDatasetId(dataset.name)
		feat.set.name <- isolate(input$selectedfeatset_corry)
		if(nchar(feat.set.name) == 0)
			return()
		res.set <- GetFeaturesetFromName(feat.set.name)
		target.fs <- AssignFeatureSet(c(GetTargetIndex(dataset.id) - 2), dataset.id)
		InitStats()
		res.list <- CorrelationY(res.set, target.fs, dataset.id)
		df <- CorryResult(res.list, res.set, dataset.id)
		p1 <- mPlot(x = 'Feature', y = list('CorrValue'), data = df, type = 'Bar', labels =
list("Correlation Value"))
		p1$set(xLabel="Features")
		p1$addParams(dom="corryresult")
		return(p1)
		
	})
	# coeff igd result
	output$coefflearnresult_igd <- renderChart({
		if(is.null(input$execoefflearnigd)  || input$execoefflearnigd == 0)
			return()
		dataset.name <- isolate(input$dataset)
		dataset.id <- GetDatasetId(dataset.name)
		feat.set.name <- isolate(input$selectedfeatset_coefflearn)
		if(nchar(feat.set.name) == 0)
			return()
		res.set <- GetFeaturesetFromName(feat.set.name)
		InitStats()
		inp.num.iters <- isolate(input$igd_numiters)
		inp.init.wt <- isolate(input$igd_initwt)
		inp.step.size <- isolate(input$igd_learnrate)
		
		out.list <- CoeffLearner(res.set, type = "igd", num.iters = inp.num.iters, step.size = inp.step.size, init.wt = inp.init.wt, dataset.id = dataset.id)
		list.id <- out.list$list.id
		res.list <- GetFeatureMap(list.id)
		df <- CorryResult(res.list, res.set, dataset.id)
		p1 <- mPlot(x = 'Feature', y = list('CorrValue'), data = df, type = 'Bar', labels =
list("Cofficient Value"))
		p1$set(xLabel="Features")
		p1$addParams(dom="coefflearnresult_igd")
		return(p1)
		
		
	})
		
	# coeff cg result
	output$coefflearnresult_cg <- renderChart({
		if(is.null(input$execoefflearncg)  || input$execoefflearncg == 0)
			return()
		dataset.name <- isolate(input$dataset)
		dataset.id <- GetDatasetId(dataset.name)
		feat.set.name <- isolate(input$selectedfeatset_coefflearn)
		if(nchar(feat.set.name) == 0)
			return()
		res.set <- GetFeaturesetFromName(feat.set.name)
		InitStats()
		inp.num.iters <- isolate(input$igd_numiters)
		inp.init.wt <- isolate(input$igd_initwt)
		inp.step.size <- isolate(input$igd_learnrate)
		
		out.list <- CoeffLearner(res.set, type = "cg", num.iters = inp.num.iters, step.size = inp.step.size, init.wt = inp.init.wt, dataset.id = dataset.id)
		list.id <- out.list$list.id
		res.list <- GetFeatureMap(list.id)
		df <- CoeffCgResult(res.list, res.set, dataset.id)
		p1 <- mPlot(x = 'Feature', y = list('CoeffValue'), data = df, type = 'Bar', labels =
list("Cofficient Value"))
		p1$set(xLabel="Features")
    		p1$addParams(dom="coefflearnresult_cg")
		return(p1)
		
		
	})
	output$evalcvresult_cg <- renderText({
		if(is.null(input$exeevalcvcg)  || input$exeevalcvcg == 0)
			return()
		dataset.name <- isolate(input$dataset)
		dataset.id <- GetDatasetId(dataset.name)
		feat.set.name <- isolate(input$selectedfeatset_eval_cv)
		if(nchar(feat.set.name) == 0)
			return()
		res.set <- GetFeaturesetFromName(feat.set.name)
		InitStats()
		inp.num.iters <- isolate(input$eval_cv_cg_numiters)
		inp.num.folds <- isolate(input$eval_cv_numfolds)

		out.cv.list <- Evaluate(res.set, train.type = "cg", eval.type=
"cv", dataset.id = dataset.id, num.iters = inp.num.iters, num.folds = inp.num.folds)
		list.id <- out.cv.list$list.id
		res.list <- GetFeatureMap(list.id)
		coeff.list.stepnum <- GetStepNumForListId(list.id)
		coeff.list.id <- GetInputList.1(coeff.list.stepnum)
		coeff.list <- GetFeatureMapValues(coeff.list.id)
		res.eval <- EvalCgCvResult(res.list, coeff.list, res.set, dataset.id)
		coeff.df <- res.eval$coeff.df
		cv.values <- res.eval$cv.values
		p2 <- nPlot(values ~ featurename, group = 'foldnum', data = subset(coeff.df), type = 'multiBarChart')
		p2$chart(color = c('brown', 'blue', '#594c26', 'green', 'orange'))
    		p2$addParams(dom="evalcoeffresult_cg")
		mdb$tmp.plt <<- p2
		return(cv.values)
	})

	# eval aic cg
	output$evalaicresult_cg <- renderText({
		if(is.null(input$exeevalaiccg)  || input$exeevalaiccg == 0)
			return()
		dataset.name <- isolate(input$dataset)
		dataset.id <- GetDatasetId(dataset.name)
		feat.set.name <- isolate(input$selectedfeatset_eval_cv)
		if(nchar(feat.set.name) == 0)
			return()
		res.set <- GetFeaturesetFromName(feat.set.name)
		InitStats()
		inp.num.iters <- isolate(input$eval_aic_cg_numiters)
		inp.num.folds <- 1

		out.cv.list <- Evaluate(res.set, train.type = "cg", eval.type=
"aic", dataset.id = dataset.id, num.iters = inp.num.iters, num.folds = inp.num.folds)
		list.id <- out.cv.list$list.id
		res.list <- GetFeatureMap(list.id)
		coeff.list.stepnum <- GetStepNumForListId(list.id)
		coeff.list.id <- GetInputList.1(coeff.list.stepnum)
		coeff.list <- GetFeatureMapValues(coeff.list.id)
		res.eval <- EvalCgAicResult(res.list, coeff.list, res.set, dataset.id)
		coeff.df <- res.eval$coeff.df
		cv.values <- res.eval$cv.values
		p2 <- nPlot(values ~ featurename, group = 'foldnum', data = subset(coeff.df), type = 'multiBarChart')
		p2$chart(color = c('brown', 'blue', '#594c26', 'green', 'orange'))
    		p2$addParams(dom="evalcoeffresult_aic_cg")
		mdb$tmp.plt <<- p2
		return(cv.values)
	})
	output$runtimechart_evalcv_cg <- renderChart({
		if(is.null(input$viewplotscvcg) || input$viewplotscvcg == 0)
			return()
		print(stats.list)
		if(length(stats.list$batch.idx) == 0)
			return()
	#	runtime.flag <- (input$runtime_cv_igd)
	#	print(runtime.flag)
	#	if(runtime.flag == 'No')
	#		return()
		#print(input$view)
		try(d <- GetNPlotDF(stats.list, 1000))
    		p2 <- nPlot(Time.Taken ~ Batch, group = 'OpType', data = d, type = 'multiBarChart')
		p2$chart(color = c('blue', 'red', 'brown', 'orange'))
		p2$addParams(dom = 'runtimechart_evalcv_cg')
		#p2 <- 'Out of runtime routine'
		return(p2)
		
		
	})

	# aic cg runtime chart
	output$runtimechart_evalaic_cg <- renderChart({
		if(is.null(input$viewplotsaiccg) || input$viewplotsaiccg == 0)
			return()
		print(stats.list)
		if(length(stats.list$batch.idx) == 0)
			return()
	#	runtime.flag <- (input$runtime_cv_igd)
	#	print(runtime.flag)
	#	if(runtime.flag == 'No')
	#		return()
		#print(input$view)
		try(d <- GetNPlotDF(stats.list, 1000))
    		p2 <- nPlot(Time.Taken ~ Batch, group = 'OpType', data = d, type = 'multiBarChart')
		p2$chart(color = c('blue', 'red', 'brown', 'orange'))
		p2$addParams(dom = 'runtimechart_evalaic_cg')
		#p2 <- 'Out of runtime routine'
		return(p2)
		
		
	})
	# eval cv cg result
	output$evalcoeffresult_cg <- renderChart({
		if(is.null(input$viewplotscvcg) || input$viewplotscvcg == 0)
			return()
		p2 <- mdb$tmp.plt
		return(p2)
	})
	# eval cv igd result
	output$evalcoeffresult_igd <- renderChart({
		if(is.null(input$viewplotscvigd) || input$viewplotscvigd == 0)
			return()
		p2 <- mdb$tmp.plt
		return(p2)
	})
	
	# eval cv cg result
	output$evalcoeffresult_aic_cg <- renderChart({
		if(is.null(input$viewplotscvcg) || input$viewplotscvcg == 0)
			return()
		p2 <- mdb$tmp.plt
		return(p2)
	})
	# eval cv igd result
	output$runtimechart_evalcv_igd <- renderChart({
		if(is.null(input$viewplotscvigd) || input$viewplotscvigd == 0)
			return()
		print(stats.list)
		if(length(stats.list$batch.idx) == 0)
			return()
	#	runtime.flag <- (input$runtime_cv_igd)
	#	print(runtime.flag)
	#	if(runtime.flag == 'No')
	#		return()
		#print(input$view)
		try(d <- GetNPlotDF(stats.list, 1000))
    		p2 <- nPlot(Time.Taken ~ Batch, group = 'OpType', data = d, type = 'multiBarChart')
		p2$chart(color = c('blue', 'red', 'brown', 'orange'))
		p2$addParams(dom = 'runtimechart_evalcv_igd')
		#p2 <- 'Out of runtime routine'
		return(p2)
		
		
	})


	# eval aic igd result
	output$runtimechart_evalaic_igd <- renderChart({
		if(is.null(input$viewplotsaicigd) || input$viewplotsaicigd == 0)
			return()
		print(stats.list)
		if(length(stats.list$batch.idx) == 0)
			return()
	#	runtime.flag <- (input$runtime_cv_igd)
	#	print(runtime.flag)
	#	if(runtime.flag == 'No')
	#		return()
		#print(input$view)
		try(d <- GetNPlotDF(stats.list, 1000))
    		p2 <- nPlot(Time.Taken ~ Batch, group = 'OpType', data = d, type = 'multiBarChart')
		p2$chart(color = c('blue', 'red', 'brown', 'orange'))
		p2$addParams(dom = 'runtimechart_evalaic_igd')
		#p2 <- 'Out of runtime routine'
		return(p2)
		
		
	})

	output$evalcvresult_igd <- renderText({
		if(is.null(input$exeevalcvigd)  || input$exeevalcvigd == 0)
			return()
		dataset.name <- isolate(input$dataset)
		dataset.id <- GetDatasetId(dataset.name)
		feat.set.name <- isolate(input$selectedfeatset_eval_cv)
		if(nchar(feat.set.name) == 0)
			return()
		res.set <- GetFeaturesetFromName(feat.set.name)
		InitStats()
		inp.num.iters <- isolate(input$eval_cv_igd_numiters)
		inp.init.wt <- isolate(input$eval_cv_igd_initwt)
		inp.step.size <- isolate(input$eval_cv_igd_learnrate)
		inp.num.folds <- isolate(input$eval_cv_numfolds)

		out.cv.list <- Evaluate(res.set, train.type = "igd", eval.type=
"cv", dataset.id = dataset.id, num.iters = inp.num.iters, step.size = inp.step.size, init.wt =
inp.init.wt, num.folds = inp.num.folds)
		list.id <- out.cv.list$list.id
		res.list <- GetFeatureMap(list.id)
		coeff.list.stepnum <- GetStepNumForListId(list.id)
		coeff.list.id <- GetInputList.1(coeff.list.stepnum)
		coeff.list <- GetFeatureMapValues(coeff.list.id)
		res.eval <- EvalIgdCvResult(res.list, coeff.list, res.set, dataset.id)
		coeff.df <- res.eval$coeff.df
		cv.values <- res.eval$cv.values
		p2 <- nPlot(values ~ featurename, group = 'foldnum', data = subset(coeff.df), type = 'multiBarChart')
		p2$chart(color = c('brown', 'blue', '#594c26', 'green', 'orange'))
    		p2$addParams(dom="evalcoeffresult_igd")
		mdb$tmp.plt <<- p2
		return(cv.values)
	})
	# aic igd coeff	
	output$evalcoeffresult_aic_igd <- renderChart({
		if(is.null(input$viewplotsaicigd) || input$viewplotsaicigd == 0)
			return()
		p2 <- mdb$tmp.plt
		return(p2)
	})
	# aic vcg coeff	
	output$evalcoeffresult_aic_cg <- renderChart({
		if(is.null(input$viewplotsaiccg) || input$viewplotsaiccg == 0)
			return()
		p2 <- mdb$tmp.plt
		return(p2)
	})
	# aic igd
	output$evalaicresult_igd <- renderText({
		if(is.null(input$exeevalaicigd)  || input$exeevalaicigd == 0)
			return()
		dataset.name <- isolate(input$dataset)
		dataset.id <- GetDatasetId(dataset.name)
		feat.set.name <- isolate(input$selectedfeatset_eval_aic)
		if(nchar(feat.set.name) == 0)
			return()
		res.set <- GetFeaturesetFromName(feat.set.name)
		InitStats()
		inp.num.iters <- isolate(input$eval_aic_igd_numiters)
		inp.init.wt <- isolate(input$eval_aic_igd_initwt)
		inp.step.size <- isolate(input$eval_aic_igd_learnrate)
		inp.num.folds <- 1

		out.cv.list <- Evaluate(res.set, train.type = "igd", eval.type=
"aic", dataset.id = dataset.id, num.iters = inp.num.iters, step.size = inp.step.size, init.wt =
inp.init.wt, num.folds = 1)
		list.id <- out.cv.list$list.id
		res.list <- GetFeatureMap(list.id)
		coeff.list.stepnum <- GetStepNumForListId(list.id)
		coeff.list.id <- GetInputList.1(coeff.list.stepnum)
		coeff.list <- GetFeatureMapValues(coeff.list.id)
		res.eval <- EvalIgdAicResult(res.list, coeff.list, res.set, dataset.id)
		coeff.df <- res.eval$coeff.df
		cv.values <- res.eval$cv.values
		p2 <- nPlot(values ~ featurename, group = 'foldnum', data = subset(coeff.df), type = 'multiBarChart')
		p2$chart(color = c('brown', 'blue', '#594c26', 'green', 'orange'))
    		p2$addParams(dom="evalcoeffresult_aic_igd")
		mdb$tmp.plt <<- p2
		return(cv.values)
	})

	
	output$updateOptypeRadioButton <- renderText({
		updateRadioButtons(session, "optype", "Operation Type :",
				c("Create Feature set" = "create",
				  "Execute Operation" = "execute",
				  "None" = "none"
				  ), selected = "None"
		)
		return('')
	})

	output$updateOpClassRadioButton <- renderText({
		updateRadioButtons(session, "opclass", "Class :",
				c( "Descriptive Statistics" = "descstat",
				  "Explore" = "explore",
				  "Evaluate" = "evaluate",
				  "None" = "none"), selected = "None"
		)
		return('')
	})
	
	output$updateDesctypeRadioButton <- renderText({
		updateRadioButtons(session, "descstat_type", "Descriptive Stat type", 
				c("Mutual Correlation" = "corrx",
				  "Correlation with target" = "corry",
				  "Learn Coefficients" = "coefflearn",
				  "None" = "none"
				  ), selected = "None"
		)
		return('')
		
	})
	output$updateEvaltypeRadioButton <- renderText({
		UpdateRadioButtons(session, "eval_type", "Evaluation type", 
				c("Cross validation" = "eval_cv",
				  "Akaike Information Criterian" = "eval_aic",
				  "None" = "none"
				  ), selected = "None"
		)
		return('')
		
	})
		
	output$updateRuntimeCvIgdRadioButton <- renderText({
		UpdateRadioButtons(session, "runtime_cv_igd", "Show Runtime :",
			c("Yes" = "Yes", "No" = "No"),
			selected = "No"
		)
	})

	output$updateEvalCoefftypeRadioButton <- renderText({
		UpdateRadioButtons(session, "eval_cv_coefflearn_type", "Coeff Learn Type :",
			c("IGD" = "eval_cv_igd", "CG" = "eval_cv_cg", "None"
= "none"),
			selected = "None"
		)
				
	})

	output$text_coeffvalues_aic_cg <- renderUI({
		if(is.null(input$viewplotsaiccg) || input$viewplotsaiccg == 0)
			return()
		return(h4('Coefficient values'))
	})

	output$text_coeffvalues_aic_igd <- renderUI({
		if(is.null(input$viewplotsaicigd) || input$viewplotsaicigd == 0)
			return()
		return(h4('Coefficient values'))
	})

	output$text_coeffvalues_cv_cg <- renderUI({
		if(is.null(input$viewplotscvcg) || input$viewplotscvcg == 0)
			return()
		return(h4('Coefficient values'))
	})
	output$text_coeffvalues_cv_igd <- renderUI({
		if(is.null(input$viewplotscvigd) || input$viewplotscvigd == 0)
			return()
		return(h4('Coefficient values'))
	})

	output$text_runtime_cv_igd <- renderUI({
		if(is.null(input$viewplotscvigd) || input$viewplotscvigd == 0)
			return()
		if(length(stats.list$batch.idx) == 0)
			return(h4('Runtime : All results are re-used'))
		else
			return(h4('Runtime :'))
	})
	
	output$text_runtime_cv_cg <- renderUI({
		if(is.null(input$viewplotscvcg) || input$viewplotscvcg == 0)
			return()
		if(length(stats.list$batch.idx) == 0)
			return(h4('Runtime : All results are re-used'))
		else
			return(h4('Runtime :'))
	})

	output$text_runtime_aic_igd <- renderUI({
		if(is.null(input$viewplotsaicigd) || input$viewplotsaicigd == 0)
			return()
		if(length(stats.list$batch.idx) == 0)
			return(h4('Runtime : All results are re-used'))
		else
			return(h4('Runtime :'))
	})
	
	output$text_runtime_aic_cg <- renderUI({
		if(is.null(input$viewplotsaiccg) || input$viewplotsaiccg == 0)
			return()
		if(length(stats.list$batch.idx) == 0)
			return(h4('Runtime : All results are re-used'))
		else
			return(h4('Runtime :'))
	})

	#---------------------------- stepadd -----------------------#
	output$text_runtime_stepadd_cv_igd <- renderUI({
		if(is.null(input$viewplotsstepaddcvigd) || input$viewplotsstepaddcvigd == 0)
			return()
		if(length(stats.list$batch.idx) == 0)
			return(h4('Runtime : All results are re-used'))
		else
			return(h4('Runtime :'))
	})

	output$text_runtime_stepadd_cv_cg <- renderUI({
		if(is.null(input$viewplotsstepaddcvcg) || input$viewplotsstepaddcvcg == 0)
			return()
		if(length(stats.list$batch.idx) == 0)
			return(h4('Runtime : All results are re-used'))
		else
			return(h4('Runtime :'))
	})

	output$text_runtime_stepadd_aic_igd <- renderUI({
		if(is.null(input$viewplotsstepaddaicigd) || input$viewplotsstepaddaicigd == 0)
			return()
		if(length(stats.list$batch.idx) == 0)
			return(h4('Runtime : All results are re-used'))
		else
			return(h4('Runtime :'))
	})

	output$text_runtime_stepadd_aic_cg <- renderUI({
		if(is.null(input$viewplotsstepaddaiccg) || input$viewplotsstepaddaiccg == 0)
			return()
		if(length(stats.list$batch.idx) == 0)
			return(h4('Runtime : All results are re-used'))
		else
			return(h4('Runtime :'))
	})


	output$stepadd_newfeaturesetname <- renderUI({
		availfeatsetnames <- GetFeaturesetNames()
		idx <- length(availfeatsetnames) + 1
		while(TRUE) {
			new.name <- paste0("fs", idx)
			if( (new.name %in% availfeatsetnames) == TRUE) {
				idx <- idx + 1
			}
			break
			
		}
    		textInput("stepadd_newfeatsetname", "New Featureset id :", new.name)
	})

	output$stepadd_eval_cv_numfoldstext <- renderUI({
    		textInput("stepadd_eval_cv_numfolds", "Num folds :", "3")
		
	})

	output$runtimechart_stepadd_evalcv_igd <- renderChart({
		if(is.null(input$viewplotsstepaddcvigd) || input$viewplotsstepaddcvigd == 0)
			return()
		print(stats.list)
		if(length(stats.list$batch.idx) == 0)
			return()
		d <- GetNPlotDF(stats.list, 1000)
    		p2 <- nPlot(Time.Taken ~ Batch, group = 'OpType', data = d, type = 'multiBarChart')
		p2$chart(color = c('blue', 'red', 'brown', 'orange'))
		p2$addParams(dom = 'runtimechart_stepadd_evalcv_igd')
		return(p2)
		
	})




	output$runtimechart_stepadd_evalcv_cg <- renderChart({
		if(is.null(input$viewplotsstepaddcvcg) || input$viewplotsstepaddcvcg == 0)
			return()
		print(stats.list)
		if(length(stats.list$batch.idx) == 0)
			return()
		d <- GetNPlotDF(stats.list, 1000)
    		p2 <- nPlot(Time.Taken ~ Batch, group = 'OpType', data = d, type = 'multiBarChart')
		p2$chart(color = c('blue', 'red', 'brown', 'orange'))
		p2$addParams(dom = 'runtimechart_stepadd_evalcv_cg')
		return(p2)
		
	})

	output$runtimechart_stepadd_evalaic_igd <- renderChart({
		if(is.null(input$viewplotsstepaddaicigd) || input$viewplotsstepaddaicigd == 0)
			return()
		if(length(stats.list$batch.idx) == 0)
			return()
		d <- GetNPlotDF(stats.list, 1000)
    		p2 <- nPlot(Time.Taken ~ Batch, group = 'OpType', data = d, type = 'multiBarChart')
		p2$chart(color = c('blue', 'red', 'brown', 'orange'))
		p2$addParams(dom = 'runtimechart_stepadd_evalaic_igd')
		return(p2)
		
	})


	output$runtimechart_stepadd_evalaic_cg <- renderChart({
		if(is.null(input$viewplotsstepaddaiccg) || input$viewplotsstepaddaiccg == 0)
			return()
		if(length(stats.list$batch.idx) == 0)
			return()
		d <- GetNPlotDF(stats.list, 1000)
    		p2 <- nPlot(Time.Taken ~ Batch, group = 'OpType', data = d, type = 'multiBarChart')
		p2$chart(color = c('blue', 'red', 'brown', 'orange'))
		p2$addParams(dom = 'runtimechart_stepadd_evalaic_cg')
		return(p2)
		
	})



	output$stepadd_evalcvresult_igd <- renderTable({
		if(is.null(input$exestepaddevalcvigd)  || input$exestepaddevalcvigd == 0)
			return()
		dataset.name <- isolate(input$dataset)
		dataset.id <- GetDatasetId(dataset.name)
		inp.feat.set.name <- isolate(input$selectedfeatset_stepadd_inp)
		mask.feat.set.name <- isolate(input$selectedfeatset_stepadd_mask)
		if(nchar(inp.feat.set.name) == 0)
			return()
		inp.set <- GetFeaturesetFromName(inp.feat.set.name)
		mask.set <- GetFeaturesetFromName(mask.feat.set.name)
		InitStats()
		inp.num.iters <- isolate(input$stepadd_eval_cv_igd_numiters)
		inp.init.wt <- isolate(input$stepadd_eval_cv_igd_initwt)
		inp.step.size <- isolate(input$stepadd_eval_cv_igd_learnrate)
		inp.num.folds <- isolate(input$stepadd_eval_cv_numfolds)

		out.set <- StepAdd(inp.set, mask.set, train.type = "igd", eval.type=
"cv", dataset.id = dataset.id, num.iters = inp.num.iters, step.size = inp.step.size, init.wt =
inp.init.wt, num.folds = inp.num.folds)
		out.set.names <- paste(GetFeatureNames(unlist(out.set$set.val), dataset.id), collapse = ",")
		add.feat.name <- GetFeatureNames(setdiff(unlist(out.set$set.val), as.numeric(unlist(inp.set$set.val))), dataset.id)
		df.names <- c("Input Feature set", "Mask Feature set", "Added feature", "New Feature set") 

		inp.set.names <- paste(GetFeatureNames(as.numeric(unlist(inp.set$set.val)), dataset.id), collapse = ",") 
		mask.set.names <- paste(GetFeatureNames(as.numeric(unlist(mask.set$set.val)), dataset.id), collapse = ",") 
		featureinfo <- c(inp.set.names, mask.set.names, add.feat.name, out.set.names)
		out.df <- data.frame(df.names, featureinfo)
		names(out.df) <- c("Info", "Featureset")
		new.featset.name <- isolate(input$stepadd_newfeatsetname)
		if( (new.featset.name %in% GetFeaturesetNames()) == FALSE)
    			UpdateFeaturesetName(new.featset.name, out.set)
		return(out.df)
		
	})
	

	output$stepadd_evalcvresult_cg <- renderTable({
		if(is.null(input$exestepaddevalcvcg)  || input$exestepaddevalcvcg == 0)
			return()
		dataset.name <- isolate(input$dataset)
		dataset.id <- GetDatasetId(dataset.name)
		inp.feat.set.name <- isolate(input$selectedfeatset_stepadd_inp)
		mask.feat.set.name <- isolate(input$selectedfeatset_stepadd_mask)
		if(nchar(inp.feat.set.name) == 0)
			return()
		inp.set <- GetFeaturesetFromName(inp.feat.set.name)
		mask.set <- GetFeaturesetFromName(mask.feat.set.name)
		InitStats()
		inp.num.iters <- isolate(input$stepadd_eval_cv_cg_numiters)
		inp.num.folds <- isolate(input$stepadd_eval_cv_numfolds)

		out.set <- StepAdd(inp.set, mask.set, train.type = "cg", eval.type= "cv", dataset.id = dataset.id, num.iters = inp.num.iters, num.folds = inp.num.folds)
		out.set.names <- paste(GetFeatureNames(unlist(out.set$set.val), dataset.id), collapse = ",")
		add.feat.name <- GetFeatureNames(setdiff(unlist(out.set$set.val), as.numeric(unlist(inp.set$set.val))), dataset.id)
		df.names <- c("Input Feature set", "Mask Feature set", "Added feature", "New Feature set") 

		inp.set.names <- paste(GetFeatureNames(as.numeric(unlist(inp.set$set.val)), dataset.id), collapse = ",") 
		mask.set.names <- paste(GetFeatureNames(as.numeric(unlist(mask.set$set.val)), dataset.id), collapse = ",") 
		featureinfo <- c(inp.set.names, mask.set.names, add.feat.name, out.set.names)
		out.df <- data.frame(df.names, featureinfo)
		names(out.df) <- c("Info", "Featureset")
		new.featset.name <- isolate(input$stepadd_newfeatsetname)
		if( (new.featset.name %in% GetFeaturesetNames()) == FALSE)
    			UpdateFeaturesetName(new.featset.name, out.set)
		return(out.df)
		
	})

	output$stepadd_evalaicresult_igd <- renderTable({
		if(is.null(input$exestepaddevalaicigd)  || input$exestepaddevalaicigd == 0)
			return()
		dataset.name <- isolate(input$dataset)
		dataset.id <- GetDatasetId(dataset.name)
		inp.feat.set.name <- isolate(input$selectedfeatset_stepadd_inp)
		mask.feat.set.name <- isolate(input$selectedfeatset_stepadd_mask)
		if(nchar(inp.feat.set.name) == 0)
			return()
		inp.set <- GetFeaturesetFromName(inp.feat.set.name)
		mask.set <- GetFeaturesetFromName(mask.feat.set.name)
		InitStats()
		inp.num.iters <- isolate(input$stepadd_eval_aic_igd_numiters)
		inp.init.wt <- isolate(input$stepadd_eval_aic_igd_initwt)
		inp.step.size <- isolate(input$stepadd_eval_aic_igd_learnrate)
		inp.num.folds <- 1

		out.set <- StepAdd(inp.set, mask.set, train.type = "igd", eval.type= "aic", dataset.id = dataset.id, num.iters = inp.num.iters, step.size = inp.step.size, init.wt = inp.init.wt, num.folds = inp.num.folds)
		out.set.names <- paste(GetFeatureNames(unlist(out.set$set.val), dataset.id), collapse = ",")
		add.feat.name <- GetFeatureNames(setdiff(unlist(out.set$set.val), as.numeric(unlist(inp.set$set.val))), dataset.id)
		df.names <- c("Input Feature set", "Mask Feature set", "Added feature", "New Feature set") 

		inp.set.names <- paste(GetFeatureNames(as.numeric(unlist(inp.set$set.val)), dataset.id), collapse = ",") 
		mask.set.names <- paste(GetFeatureNames(as.numeric(unlist(mask.set$set.val)), dataset.id), collapse = ",") 
		featureinfo <- c(inp.set.names, mask.set.names, add.feat.name, out.set.names)
		out.df <- data.frame(df.names, featureinfo)
		names(out.df) <- c("Info", "Featureset")
		new.featset.name <- isolate(input$stepadd_newfeatsetname)
		if( (new.featset.name %in% GetFeaturesetNames()) == FALSE)
    			UpdateFeaturesetName(new.featset.name, out.set)
		return(out.df)
		
	})


	output$stepadd_evalaicresult_cg <- renderTable({
		if(is.null(input$exestepaddevalaiccg)  || input$exestepaddevalaiccg == 0)
			return()
		dataset.name <- isolate(input$dataset)
		dataset.id <- GetDatasetId(dataset.name)
		inp.feat.set.name <- isolate(input$selectedfeatset_stepadd_inp)
		mask.feat.set.name <- isolate(input$selectedfeatset_stepadd_mask)
		if(nchar(inp.feat.set.name) == 0)
			return()
		inp.set <- GetFeaturesetFromName(inp.feat.set.name)
		mask.set <- GetFeaturesetFromName(mask.feat.set.name)
		InitStats()
		inp.num.iters <- isolate(input$stepadd_eval_aic_cg_numiters)
		inp.num.folds <- 1

		out.set <- StepAdd(inp.set, mask.set, train.type = "cg", eval.type= "aic", dataset.id = dataset.id, num.iters = inp.num.iters, num.folds = inp.num.folds)
		out.set.names <- paste(GetFeatureNames(unlist(out.set$set.val), dataset.id), collapse = ",")
		add.feat.name <- GetFeatureNames(setdiff(unlist(out.set$set.val), as.numeric(unlist(inp.set$set.val))), dataset.id)
		df.names <- c("Input Feature set", "Mask Feature set", "Added feature", "New Feature set") 

		inp.set.names <- paste(GetFeatureNames(as.numeric(unlist(inp.set$set.val)), dataset.id), collapse = ",") 
		mask.set.names <- paste(GetFeatureNames(as.numeric(unlist(mask.set$set.val)), dataset.id), collapse = ",") 
		featureinfo <- c(inp.set.names, mask.set.names, add.feat.name, out.set.names)
		out.df <- data.frame(df.names, featureinfo)
		names(out.df) <- c("Info", "Featureset")
		new.featset.name <- isolate(input$stepadd_newfeatsetname)
		if( (new.featset.name %in% GetFeaturesetNames()) == FALSE)
    			UpdateFeaturesetName(new.featset.name, out.set)
		return(out.df)
		
	})

	# --------------- step drop ------------------
	
	output$text_runtime_stepdrop_cv_igd <- renderUI({
		if(is.null(input$viewplotsstepdropcvigd) || input$viewplotsstepdropcvigd == 0)
			return()
		if(length(stats.list$batch.idx) == 0)
			return(h4('Runtime : All results are re-used'))
		else
			return(h4('Runtime :'))
	})

	output$text_runtime_stepdrop_cv_cg <- renderUI({
		if(is.null(input$viewplotsstepdropcvcg) || input$viewplotsstepdropcvcg == 0)
			return()
		if(length(stats.list$batch.idx) == 0)
			return(h4('Runtime : All results are re-used'))
		else
			return(h4('Runtime :'))
	})

	output$text_runtime_stepdrop_aic_igd <- renderUI({
		if(is.null(input$viewplotsstepdropaicigd) || input$viewplotsstepdropaicigd == 0)
			return()
		if(length(stats.list$batch.idx) == 0)
			return(h4('Runtime : All results are re-used'))
		else
			return(h4('Runtime :'))
	})

	output$text_runtime_stepdrop_aic_cg <- renderUI({
		if(is.null(input$viewplotsstepdropaiccg) || input$viewplotsstepdropaiccg == 0)
			return()
		if(length(stats.list$batch.idx) == 0)
			return(h4('Runtime : All results are re-used'))
		else
			return(h4('Runtime :'))
	})


	output$stepdrop_newfeaturesetname <- renderUI({
		availfeatsetnames <- GetFeaturesetNames()
		idx <- length(availfeatsetnames) + 1
		while(TRUE) {
			new.name <- paste0("fs", idx)
			if( (new.name %in% availfeatsetnames) == TRUE) {
				idx <- idx + 1
			}
			break
			
		}
    		textInput("stepdrop_newfeatsetname", "New Featureset id :", new.name)
	})
	
	output$stepdrop_eval_cv_numfoldstext <- renderUI({
    		textInput("stepdrop_eval_cv_numfolds", "Num folds :", "3")
		
	})

	output$runtimechart_stepdrop_evalcv_igd <- renderChart({
		if(is.null(input$viewplotsstepdropcvigd) || input$viewplotsstepdropcvigd == 0)
			return()
		print(stats.list)
		if(length(stats.list$batch.idx) == 0)
			return()
		d <- GetNPlotDF(stats.list, 1000)
    		p2 <- nPlot(Time.Taken ~ Batch, group = 'OpType', data = d, type = 'multiBarChart')
		p2$chart(color = c('blue', 'red', 'brown', 'orange'))
		p2$addParams(dom = 'runtimechart_stepdrop_evalcv_igd')
		return(p2)
		
	})




	output$runtimechart_stepdrop_evalcv_cg <- renderChart({
		if(is.null(input$viewplotsstepdropcvcg) || input$viewplotsstepdropcvcg == 0)
			return()
		print(stats.list)
		if(length(stats.list$batch.idx) == 0)
			return()
		d <- GetNPlotDF(stats.list, 1000)
    		p2 <- nPlot(Time.Taken ~ Batch, group = 'OpType', data = d, type = 'multiBarChart')
		p2$chart(color = c('blue', 'red', 'brown', 'orange'))
		p2$addParams(dom = 'runtimechart_stepdrop_evalcv_cg')
		return(p2)
		
	})

	output$runtimechart_stepdrop_evalaic_igd <- renderChart({
		if(is.null(input$viewplotsstepdropaicigd) || input$viewplotsstepdropaicigd == 0)
			return()
		if(length(stats.list$batch.idx) == 0)
			return()
		d <- GetNPlotDF(stats.list, 1000)
    		p2 <- nPlot(Time.Taken ~ Batch, group = 'OpType', data = d, type = 'multiBarChart')
		p2$chart(color = c('blue', 'red', 'brown', 'orange'))
		p2$addParams(dom = 'runtimechart_stepdrop_evalaic_igd')
		return(p2)
		
	})


	output$runtimechart_stepdrop_evalaic_cg <- renderChart({
		if(is.null(input$viewplotsstepdropaiccg) || input$viewplotsstepdropaiccg == 0)
			return()
		if(length(stats.list$batch.idx) == 0)
			return()
		d <- GetNPlotDF(stats.list, 1000)
    		p2 <- nPlot(Time.Taken ~ Batch, group = 'OpType', data = d, type = 'multiBarChart')
		p2$chart(color = c('blue', 'red', 'brown', 'orange'))
		p2$addParams(dom = 'runtimechart_stepdrop_evalaic_cg')
		return(p2)
		
	})

	output$stepdrop_evalcvresult_igd <- renderTable({
		if(is.null(input$exestepdropevalcvigd)  || input$exestepdropevalcvigd == 0)
			return()
		dataset.name <- isolate(input$dataset)
		dataset.id <- GetDatasetId(dataset.name)
		inp.feat.set.name <- isolate(input$selectedfeatset_stepdrop_inp)
		if(nchar(inp.feat.set.name) == 0)
			return()
		inp.set <- GetFeaturesetFromName(inp.feat.set.name)
		InitStats()
		inp.num.iters <- isolate(input$stepdrop_eval_cv_igd_numiters)
		inp.init.wt <- isolate(input$stepdrop_eval_cv_igd_initwt)
		inp.step.size <- isolate(input$stepdrop_eval_cv_igd_learnrate)
		inp.num.folds <- isolate(input$stepdrop_eval_cv_numfolds)

		out.set <- StepDel(inp.set, train.type = "igd", eval.type= "cv", dataset.id = dataset.id, num.iters = inp.num.iters, step.size = inp.step.size, init.wt =
inp.init.wt, num.folds = inp.num.folds)
		out.set.names <- paste(GetFeatureNames(unlist(out.set$set.val), dataset.id), collapse = ",")
		add.feat.name <- GetFeatureNames(setdiff(as.numeric(unlist(inp.set$set.val)),unlist(out.set$set.val)), dataset.id)
		df.names <- c("Input Feature set", "Deleted feature", "New Feature set") 

		inp.set.names <- paste(GetFeatureNames(as.numeric(unlist(inp.set$set.val)), dataset.id), collapse = ",") 
		featureinfo <- c(inp.set.names, add.feat.name, out.set.names)
		out.df <- data.frame(df.names, featureinfo)
		names(out.df) <- c("Info", "Featureset")
		new.featset.name <- isolate(input$stepdrop_newfeatsetname)
		if( (new.featset.name %in% GetFeaturesetNames()) == FALSE)
    			UpdateFeaturesetName(new.featset.name, out.set)
		return(out.df)
		
	})
	

	output$stepdrop_evalcvresult_igd <- renderTable({
		if(is.null(input$exestepdropevalcvigd)  || input$exestepdropevalcvigd == 0)
			return()
		dataset.name <- isolate(input$dataset)
		dataset.id <- GetDatasetId(dataset.name)
		inp.feat.set.name <- isolate(input$selectedfeatset_stepdrop_inp)
		mask.feat.set.name <- isolate(input$selectedfeatset_stepdrop_mask)
		if(nchar(inp.feat.set.name) == 0)
			return()
		inp.set <- GetFeaturesetFromName(inp.feat.set.name)
		InitStats()
		inp.num.iters <- isolate(input$stepdrop_eval_cv_igd_numiters)
		inp.init.wt <- isolate(input$stepdrop_eval_cv_igd_initwt)
		inp.step.size <- isolate(input$stepdrop_eval_cv_igd_learnrate)
		inp.num.folds <- isolate(input$stepdrop_eval_cv_numfolds)

		out.set <- StepDel(inp.set, train.type = "igd", eval.type=
"cv", dataset.id = dataset.id, num.iters = inp.num.iters, step.size = inp.step.size, init.wt =
inp.init.wt, num.folds = inp.num.folds)
		out.set.names <- paste(GetFeatureNames(unlist(out.set$set.val), dataset.id), collapse = ",")
		add.feat.name <- GetFeatureNames(setdiff(as.numeric(unlist(inp.set$set.val)),unlist(out.set$set.val)), dataset.id)
		df.names <- c("Input Feature set", "Deleted feature", "New Feature set") 

		inp.set.names <- paste(GetFeatureNames(as.numeric(unlist(inp.set$set.val)), dataset.id), collapse = ",") 
		mask.set.names <- paste(GetFeatureNames(as.numeric(unlist(mask.set$set.val)), dataset.id), collapse = ",") 
		featureinfo <- c(inp.set.names, add.feat.name, out.set.names)
		out.df <- data.frame(df.names, featureinfo)
		names(out.df) <- c("Info", "Featureset")
		new.featset.name <- isolate(input$stepdrop_newfeatsetname)
		if( (new.featset.name %in% GetFeaturesetNames()) == FALSE)
    			UpdateFeaturesetName(new.featset.name, out.set)
		return(out.df)
		
	})
	

	output$stepdrop_evalaicresult_igd <- renderTable({
		if(is.null(input$exestepdropevalaicigd)  || input$exestepdropevalaicigd == 0)
			return()
		dataset.name <- isolate(input$dataset)
		dataset.id <- GetDatasetId(dataset.name)
		inp.feat.set.name <- isolate(input$selectedfeatset_stepdrop_inp)
		mask.feat.set.name <- isolate(input$selectedfeatset_stepdrop_mask)
		if(nchar(inp.feat.set.name) == 0)
			return()
		inp.set <- GetFeaturesetFromName(inp.feat.set.name)
		InitStats()
		inp.num.iters <- isolate(input$stepdrop_eval_aic_igd_numiters)
		inp.init.wt <- isolate(input$stepdrop_eval_aic_igd_initwt)
		inp.step.size <- isolate(input$stepdrop_eval_aic_igd_learnrate)
		inp.num.folds <- 1

		out.set <- StepDel(inp.set, train.type = "igd", eval.type= "aic", dataset.id = dataset.id, num.iters = inp.num.iters, step.size = inp.step.size, init.wt = inp.init.wt, num.folds = inp.num.folds)
		out.set.names <- paste(GetFeatureNames(unlist(out.set$set.val), dataset.id), collapse = ",")
		add.feat.name <- GetFeatureNames(setdiff(as.numeric(unlist(inp.set$set.val)),unlist(out.set$set.val)), dataset.id)
		df.names <- c("Input Feature set", "Deleted feature", "New Feature set") 

		inp.set.names <- paste(GetFeatureNames(as.numeric(unlist(inp.set$set.val)), dataset.id), collapse = ",") 
		featureinfo <- c(inp.set.names, add.feat.name, out.set.names)
		out.df <- data.frame(df.names, featureinfo)
		names(out.df) <- c("Info", "Featureset")
		new.featset.name <- isolate(input$stepdrop_newfeatsetname)
		if( (new.featset.name %in% GetFeaturesetNames()) == FALSE)
    			UpdateFeaturesetName(new.featset.name, out.set)
		return(out.df)
		
	})


	output$stepdrop_evalaicresult_cg <- renderTable({
		if(is.null(input$exestepdropevalaiccg)  || input$exestepdropevalaiccg == 0)
			return()
		dataset.name <- isolate(input$dataset)
		dataset.id <- GetDatasetId(dataset.name)
		inp.feat.set.name <- isolate(input$selectedfeatset_stepdrop_inp)
		mask.feat.set.name <- isolate(input$selectedfeatset_stepdrop_mask)
		if(nchar(inp.feat.set.name) == 0)
			return()
		inp.set <- GetFeaturesetFromName(inp.feat.set.name)
		InitStats()
		inp.num.iters <- isolate(input$stepdrop_eval_aic_cg_numiters)
		inp.num.folds <- 1

		out.set <- StepDel(inp.set, train.type = "cg", eval.type= "aic", dataset.id = dataset.id, num.iters = inp.num.iters, num.folds = inp.num.folds)
		out.set.names <- paste(GetFeatureNames(unlist(out.set$set.val), dataset.id), collapse = ",")
		add.feat.name <- GetFeatureNames(setdiff(as.numeric(unlist(inp.set$set.val)),unlist(out.set$set.val)), dataset.id)
		df.names <- c("Input Feature set", "Added feature", "New Feature set") 

		inp.set.names <- paste(GetFeatureNames(as.numeric(unlist(inp.set$set.val)), dataset.id), collapse = ",") 
		featureinfo <- c(inp.set.names, add.feat.name, out.set.names)
		out.df <- data.frame(df.names, featureinfo)
		names(out.df) <- c("Info", "Featureset")
		new.featset.name <- isolate(input$stepdrop_newfeatsetname)
		if( (new.featset.name %in% GetFeaturesetNames()) == FALSE)
    			UpdateFeaturesetName(new.featset.name, out.set)
		return(out.df)
		
	})
#------------------------------------------ save pgm ----------------------------
	output$savepgmtextinput <- renderUI({
		textInput("savepgmname", "Feature set name", "")
		
	})
	
	output$viewprogramtext <- renderUI({
		ret.str <- paste(unlist(mdb$program.lines))
		return(ret.str)
	})
	output$saveprograminformation <- renderText({
		dataset.name <- isolate(input$dataset)
		dataset.id <- GetDatasetId(dataset.name)
		if(is.null(input$saveprogram) || input$save.program == 0)
			return()
		if(length(mdb$program.lines) == 0)
			return()
			
		program.name <- isolate(input$savepgmname)
		session.id <- GetSessionId()
		program.id <- GetProgramId()
		writeLines(paste(unlist(mdb$program.lines)), con = "tt1")
		UpdateProgramInfo(session.id, program.id, program.name, "tt1", dataset.id = dataset.id) 
		return('File Saved')	
	})
})

