
#Copyright 2013 Pradap  and Arun Kumar and Christopher Re
#
#Licensed under the Apache License, Version 2.0 (the "License");
#you may not use this file except in compliance with the License.
#You may obtain a copy of the License at
#
#http://www.apache.org/licenses/LICENSE-2.0
#
#Unless required by applicable law or agreed to in writing, software
#distributed under the License is distributed on an "AS IS" BASIS,
#WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#See the License for the specific language governing permissions and
#limitations under the License.
#
#
source('global.R')


GetDatasetnames()

id <- GetDatasetId("TelecomVersion2")
print(GetFeatureNames(GetFeatureIndices(id), id))

fs1 <- AssignFeatureSet(c("DATAVOLUME", "NUMMMSOUT", "NUMVASOUT", "NUMCALLSFIXEDOUT", "DURATIONFIXEDINC", "NUMSMSINTEROUT", "NUMSMSCMPINC", "NUMSMSVASINC"), dataset.id = id)
fm1 <- CorrelationX(fs1, dataset.id = id)

PlotCorrelation(fm1, dataset.id = id)

fs2 <- AssignFeatureSet(c("NUMCALLSFIXEDOUT"), dataset.id = id)
fs3 <- DelFeatureSet(fs1, fs2, dataset.id = id)
fm2 <- CoeffLearner(fs3, "igd", num.iters = 2, dataset.id = id)
fs4 <- BestK(fm2, 6, dataset.id = id)

res <- bGetNumTimesAccessed("TelecomVersion2")
print(res)
fm6 <- Evaluate(fs4, "cg", "cv", num.iters=2, num.folds=3, dataset.id=id) # change to 5 folds
res <- bGetNumTimesAccessed("TelecomVersion2")
print(res)

fs5 <- StepDel(fs4, "cg", "aic", dataset.id = id)
print(fs5)
SaveSession("ColumbusProgram1", dataset.id = id)

# plot the dag
g <- GetProgramDag("ColumbusProgram1", dataset.id = id)

renderGraph(g)

# let us do a step delete on the fs1 featureset.
fs6 <- StepDel(fs1, "cg", "aic", dataset.id = id)
print(fs6)
g <- GetProgramDag("ColumbusProgram1", dataset.id = id)

renderGraph(g)





new.dataset.id <- GetDatasetId("TelecomVersion1")
#ViewProgram("ColumbusProgram1", dataset.id = new.dataset.id)
ExecuteProgram("ColumbusProgram1", dataset.id = new.dataset.id) # BatchMode execution
g <- GetBatchProgramDag("ColumbusProgram1", dataset.id = new.dataset.id)

renderGraph(g)



# Plot results

PlotResults(stats.list)


# Plot Dag (googleVis) # pdf
# Operations to be allowed, dataset features !!!
