
#Copyright 2013 Pradap  and Arun Kumar and Christopher Re
#
#Licensed under the Apache License, Version 2.0 (the "License");
#you may not use this file except in compliance with the License.
#You may obtain a copy of the License at
#
#http://www.apache.org/licenses/LICENSE-2.0
#
#Unless required by applicable law or agreed to in writing, software
#distributed under the License is distributed on an "AS IS" BASIS,
#WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#See the License for the specific language governing permissions and
#limitations under the License.
#
#
#source('corrCircles.R')
source('sjPlotCorr.R')
printf <- function(...) sprintf(...)
printCorrelation <- function(inp, dataset.id)
{
	id <- inp$list.id
	featureList <- mdb$FeatureMapDB[id]$feature.list[[1]]
	values <- mdb$FeatureMapDB[id]$values[[1]]
	n <- length(unique(unlist(featureList)))
	browser()
	printf("n = %f", n)
	mat <- diag(rep(1, n))
	
	for(i in 1:length(featureList))
	{
		m <- unlist(featureList[i])[1]
		n <- unlist(featureList[i])[2]
		printf('m = %f, n = %f', m, n)
		#browser()
		v <- unlist(values[i])
		mat[m, n] <- v
		mat[n, m] <- v

	}
	rownames(mat) <- GetFeatureNames(unique(unlist(featureList)), dataset.id)
	colnames(mat) <- rownames(mat)

	#circle.corr(mat, order = TRUE, bg = "gray50",col = colorRampPalette(c("blue", "gray", "red"))(100))
	return(mat)
	
}
PlotCorrelation <- function(inp, dataset.id)
{
	featureList <- inp$feature.list[[1]]
	values <- inp$values[[1]]
	n <- length(unique(unlist(featureList)))
	mat <- diag(rep(1, n))
	feat.set.id <- GetInputSetId.1(inp$inst.id)
	feat.set <- unlist(GetFeatureSet(feat.set.id))
	
	for(i in 1:length(featureList))
	{
		m <- (unlist(featureList[i])[1])
		n <- (unlist(featureList[i])[2])
		v <- unlist(values[i])
		m.index <- which(m == feat.set)
		n.index <- which(n ==  feat.set)
		mat[m.index, n.index] <- v
		mat[n.index, m.index] <- v

	}
	rownames(mat) <- GetFeatureNames(unique(unlist(featureList)), dataset.id)
	colnames(mat) <- rownames(mat)

	#circle.corr(mat, order = TRUE, bg = "gray50",col = colorRampPalette(c("blue", "gray", "red"))(100))
	#return(mat)
	sjp.corr(mat, "theme" = "bw")
	
}
