
#Copyright 2013 Pradap  and Arun Kumar and Christopher Re
#
#Licensed under the Apache License, Version 2.0 (the "License");
#you may not use this file except in compliance with the License.
#You may obtain a copy of the License at
#
#http://www.apache.org/licenses/LICENSE-2.0
#
#Unless required by applicable law or agreed to in writing, software
#distributed under the License is distributed on an "AS IS" BASIS,
#WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#See the License for the specific language governing permissions and
#limitations under the License.
#
#
SkelStepAddIgdTrain <- function(inp.set, mask.set, num.iters, step.size, decay, init.wt, num.folds, dataset.id) {
	
	inp.set.val <- inp.set$set.val
	mask.set.val <- mask.set$set.val
	
	values <- list(NA)

	step.num.list <- c()
	step.num <- GetStepNum() + 1
	
	pgm.ctr <- step.num # fixed
	
	InsertRowInTable('IgdConfig', data.table(dataset.id, step.num, pgm.ctr, num.iters,
					step.size, decay, init.wt, num.folds))
	
	for(i in 1:num.iters) {
		list.id <- InsertRowInTable('FeatureMapDB', data.table(step.num, inp.set.val, values))
		step.num.list <- c(step.num.list, step.num)
		outset.id <- MNULL
		if(i == 1)	
			inplist.id <- MNULL
		else	
			inplist.id <- old.list.id
		
		res.step.num <- InsertRowInTable('Program', data.table(dataset.id,
STEPADD_EVAL_IGD_TRAIN, step.num, pgm.ctr, inp.set$feat.id, mask.set$feat.id, inplist.id, outset.id,
list.id))
		step.num <- GetStepNum() + 1
		old.list.id <- list.id
	}
	out.list <- FeatureMapClass(list.id, inp.set.val, values)
	return(list(out.list = out.list, step.num.list = step.num.list, pgm.ctr = pgm.ctr))
	
}

SkelStepAddCgTrain <- function(inp.set, mask.set, num.iters, init.wt, num.folds, dataset.id) {
	
	inp.set.val <- inp.set$set.val
	values <- list(NA)
	
	step.num.list <- c()
	step.num <- GetStepNum() + 1
	
	pgm.ctr <- step.num 
	

	InsertRowInTable('CgConfig', data.table(dataset.id, step.num, pgm.ctr, num.iters,
init.wt, num.folds))

	for(i in 1:num.iters) {
		
		list.id <- InsertRowInTable('FeatureMapDB', data.table(step.num, inp.set.val,
values))
		step.num.list <- c(step.num.list, step.num)
		outset.id <- MNULL
		
		if(i == 1)
			inplist.id <- MNULL
		else
			inplist.id <- old.list.id

		res.step.num <- InsertRowInTable('Program', data.table(dataset.id,
STEPADD_EVAL_CG_TRAIN, step.num, pgm.ctr, inp.set$feat.id, mask.set$feat.id, inplist.id, outset.id,
list.id))
		step.num <- GetStepNum() + 1
		old.list.id <- list.id

	}
	out.list <- FeatureMapClass(list.id, inp.set.val, values)
	return(list(out.list = out.list, step.num.list = step.num.list, pgm.ctr = pgm.ctr))
	
}

SkelStepAddEvalTest <- function(inp.set, mask.set, eval.type, pgm.ctr, inp.list.id, dataset.id) {

	inp.set.val <- inp.set$set.val
	values <- list(NA)
	
	step.num <- GetStepNum() + 1
	step.num.list <- c()
	step.num.list <- c(step.num.list, step.num)

	eval.type <- tolower(eval.type)
	if(eval.type == 'aic')
		EVAL_TEST <- STEPADD_EVAL_AIC_TEST
	else
		EVAL_TEST <- STEPADD_EVAL_CV_TEST	
	
    	list.id <- InsertRowInTable('FeatureMapDB', data.table(step.num, inp.set.val, values))
	outset.id <- MNULL

	res.step.num <- InsertRowInTable('Program', data.table(dataset.id, EVAL_TEST, step.num,
				pgm.ctr, inp.set$feat.id, mask.set$feat.id, inp.list.id, outset.id, list.id))
	
	out.list <- FeatureMapClass(list.id, inp.set.val, values)
	return(list(out.list = out.list, step.num.list = step.num.list, pgm.ctr = pgm.ctr))
}

SkelStepAddBestK <- function(inp.list.id, pgm.ctr, dataset.id) {

	set.val <- list(NA)
	step.num <- GetStepNum() + 1
	
	inpset.id1 <- MNULL
	inpset.id2 <- MNULL
	outlist.id <- MNULL
	

	feat.id <- InsertRowInTable('FeatureSetDB', data.table(step.num, set.val))
	res.step.num <- InsertRowInTable('Program', data.table(dataset.id, STEPADD_BEST_K, step.num,
					pgm.ctr, inpset.id1, inpset.id2, inp.list.id, feat.id, outlist.id))
	
	out.set <- FeatureSetClass(feat.id, set.val)
	return(list(step.num.list = step.num, out.set = out.set, pgm.ctr = pgm.ctr))

	
}

#------------------------------------------------------------------------------------------------#

SkelStepDelIgdTrain <- function(inp.set, num.iters, step.size, decay, init.wt, num.folds,
dataset.id) {
	
	inp.set.val <- inp.set$set.val
	values <- list(NA)
	step.num.list <- c()
	
	step.num <- GetStepNum() + 1
	
	pgm.ctr <- step.num
	
	InsertRowInTable('IgdConfig', data.table(dataset.id, step.num, pgm.ctr, num.iters,
					step.size, decay, init.wt, num.folds))
	
	
	for(i in 1:num.iters) {
		list.id <- InsertRowInTable('FeatureMapDB', data.table(step.num, inp.set.val, values))
		step.num.list <- c(step.num.list, step.num)
		outset.id <- MNULL
		inpset.id2 <- MNULL
		if(i == 1)	
			inplist.id <- MNULL
		else	
			inplist.id <- old.list.id
		
		res.step.num <- InsertRowInTable('Program', data.table(dataset.id,
STEPDEL_EVAL_IGD_TRAIN, step.num, pgm.ctr, inp.set$feat.id, inpset.id2, inplist.id, outset.id,
list.id))
		step.num <- GetStepNum() + 1
		old.list.id <- list.id
	}
	out.list <- FeatureMapClass(list.id, inp.set.val, values)
	return(list(out.list = out.list, step.num.list = step.num.list, pgm.ctr = pgm.ctr))
	
}

SkelStepDelCgTrain <- function(inp.set, num.iters, init.wt, num.folds, dataset.id) {

	inp.set.val <- inp.set$set.val
	values <- list(NA)
	step.num.list <- c()
	
	step.num <- GetStepNum() + 1
	
	pgm.ctr <- step.num
	
	InsertRowInTable('CgConfig', data.table(dataset.id, step.num, pgm.ctr, num.iters,
init.wt, num.folds))

	for(i in 1:num.iters) {
		
		list.id <- InsertRowInTable('FeatureMapDB', data.table(step.num, inp.set.val,
values))
		step.num.list <- c(step.num.list, step.num)
		outset.id <- MNULL
		inpset.id2 <- MNULL
		
		if(i == 1)
			inplist.id <- MNULL
		else
			inplist.id <- old.list.id

		res.step.num <- InsertRowInTable('Program', data.table(dataset.id,
STEPDEL_EVAL_CG_TRAIN, step.num, pgm.ctr, inp.set$feat.id, inpset.id2 , inplist.id, outset.id,
list.id))
		step.num <- GetStepNum() + 1
		old.list.id <- list.id

	}
	out.list <- FeatureMapClass(list.id, inp.set.val, values)
	return(list(out.list = out.list, step.num.list = step.num.list, pgm.ctr = pgm.ctr))
}

SkelStepDelEvalTest <- function(inp.set, eval.type, pgm.ctr, inp.list.id, dataset.id) {

	inp.set.val <- inp.set$set.val
	values <- list(NA)
	
	step.num <- GetStepNum() + 1
	step.num.list <- c()
	step.num.list <- c(step.num.list, step.num)

	eval.type <- tolower(eval.type)
	if(eval.type == 'aic')
		EVAL_TEST <- STEPDEL_EVAL_AIC_TEST
	else
		EVAL_TEST <- STEPDEL_EVAL_CV_TEST	
	
    	list.id <- InsertRowInTable('FeatureMapDB', data.table(step.num, inp.set.val, values))
	outset.id <- MNULL
	inpset.id2 <- MNULL

	res.step.num <- InsertRowInTable('Program', data.table(dataset.id, EVAL_TEST, step.num,
				pgm.ctr, inp.set$feat.id, inpset.id2, inp.list.id, outset.id, list.id))
	
	out.list <- FeatureMapClass(list.id, inp.set.val, values)
	return(list(out.list = out.list, step.num.list = step.num.list, pgm.ctr = pgm.ctr))
}
	
SkelStepDelBestK <- function(inp.list.id, pgm.ctr, dataset.id) {

	set.val <- list(NA)
	step.num <- GetStepNum() + 1
	
	inpset.id1 <- MNULL
	inpset.id2 <- MNULL
	outlist.id <- MNULL
	

	feat.id <- InsertRowInTable('FeatureSetDB', data.table(step.num, set.val))
	res.step.num <- InsertRowInTable('Program', data.table(dataset.id, STEPDEL_BEST_K, step.num,
					pgm.ctr, inpset.id1, inpset.id2, inp.list.id, feat.id, outlist.id))
	
	out.set <- FeatureSetClass(feat.id, set.val)
	return(list(step.num.list = step.num, out.set = out.set, pgm.ctr = pgm.ctr))

	
}
