
import java.nio.ByteBuffer;
import java.util.HashMap;
import java.util.Random;

import static java.lang.Integer.decode;
import static java.lang.Integer.toString;

/**
 * Created with IntelliJ IDEA.
 * User: vamshika
 * Date: 1/15/13
 * Time: 11:44 PM
 * To change this template use File | Settings | File Templates.
 */
public class Driver {

    public static double[][] fillDoubleArray(int nr, int nc)
    {
        double[][] ret = new double[nr][nc];
        double k = 0;
        for(int i = 0; i < nr; i ++)
        {
            for(int j = 0; j < nc; j ++)
            {
                ret[i][j] = k/(nr*nc);
                if(j == nc - 1)
                    if(i < nr/2)
                        ret[i][j] = 0;
                    else
                        ret[i][j] = 1;
                k ++;
            }
        }
        return(ret);
    }
    public static void initializeTupleVector(double[] d)
    {
        for(int i = 0; i < MyTuple.decodeIdx.length; i ++)
        {
            int idx = MyTuple.decodeIdx[i];
            if(idx < MyTuple.origNumFeatures)
            {
                MyTuple.xVal[idx] = d[idx];
            }
            else
            {
                String s = MyTuple.getNewFeatureString(idx);
                String splitted[] = s.split(",");
                int idx1 = Integer.parseInt(splitted[0]);
                int idx2 = Integer.parseInt(splitted[1]);
                MyTuple.xVal[idx] = d[idx1]*d[idx2];
            }

        }
        MyTuple.yVal = d[d.length - 1];
    }
    public static void initializeInStages(String initString)
    {
        //int chopLength = 3500;
        int chopLength = 3500;
        String[] resString = new String[(int) Math.ceil((double) initString.length() / (double) chopLength)];
        for(int i = 0; i < resString.length; i ++ )
        {
            resString[i]  = initString.substring(i*chopLength, Math.min(initString.length(), (i+1)*chopLength));
        }

        StringBuilder sb;

        for(int i = 0; i < resString.length; i ++)
        {
            sb = new StringBuilder();
            if(i == 0)
            {
                if(resString.length-1 == i)
                {
                    sb.append("STE%" + resString[i]);

                }
                else
                {
                    sb.append("STM%" + resString[i]);
                }
            }
            else if(i != resString.length - 1)
            {
                sb.append("MRE%" + resString[i]);
            }
            else
            {
                //last chunk
                sb.append("END%" + resString[i]);
            }
            MyUDFManager.initializeInStages(sb.toString());
        }

    }
    public static String getResultInStages(String obj)
    {
        StringBuilder res = new StringBuilder();
        String tmp;
        while(true)
        {
            tmp = MyUDFManager.getResultInStages(obj);
            String splitString[] = tmp.split("%");
            if(splitString[0].equalsIgnoreCase("MRE"))
            {
                res.append(splitString[1]);
            }
            else if(splitString[0].equalsIgnoreCase("END"))
            {
                res.append(splitString[1]);
                break;
            }
            else
            {
                return null;
            }

        }
        return res.toString();

    }
    public static void testCorrelation(double[][] d, int numFeatures, int origNumFeatures, int yIdx)
    {
        MyUDFManager.terminate();
        // initialise the tuple
        StringBuilder sb = new StringBuilder();
        sb.append(new Integer(numFeatures)).append(",").append(new Integer(origNumFeatures)).append(",").append(new Integer(yIdx));
        MyUDFManager.initNumAttributes(sb.toString());



        int[] featureVector = {1,2,3,4};

        String sInit = "1,2,3,4,31,32#1,2,1,3,1,4,2,3,2,4,3,4,4,31,3,32";
        String corrObject = MyUDFManager.createObj("descstat.corr");

        String sInitString = corrObject+"@"+sInit;
        initializeInStages(sInitString);

        //MyUDFManager.initializeInStages("STE%"+corrObject+"@"+sInit);
        MyUDFManager.initObjectList(corrObject);
        MyUDFManager.initNewFeatures("31~1,3#32~1,4");
        MyUDFManager.initDecodeIndices("1,2,3,4,31,32");
        MyUDFManager.initDecodeIndicesMap("1,2,3,4#0,1,2,3");
        MyUDFManager.setYIdx("4");
        for(int i = 0; i < d.length; i ++)
        {
            initializeTupleVector(d[i]);
            MyUDFManager.iterate();

        }

        //String res = MyUDFManager.result(corrObject);
        String res = getResultInStages(corrObject);
        System.out.println(res);
        MyUDFManager.deleteObj(corrObject);
        MyUDFManager.terminate();
    }


    public static void main(String[] args) {


        double[][] d;
        int n = 30;

        d = fillDoubleArray(10, n);
        int numFeatures = 33;


/*
        HashMap<Integer, String> hm = new HashMap<Integer, String>();
        hm.put(new Integer(31), "1,2");
        System.out.println(hm.containsKey(new Integer(32))) ;
        String s = hm.get(new Integer(32));
        String splitted[] = s.split(",");
        int f1 = Integer.parseInt(splitted[0]);
        int f2 = Integer.parseInt(splitted[1]);
        System.out.println(f1);
        System.out.println(f2);
*/

        // testCorrelation
        testCorrelation(d, numFeatures, n-1, n-1 );

        //testEvaluateLRCV(d, numFeatures);

        //testCGTrain(d, numFeatures);

        //aicTest(d, numFeatures);

        // correlation + lrcv train

        //MyUDFManager.terminate();
        // initialise the tuple
        //MyUDFManager.initNumAttributes(new Integer(numFeatures-1).toString());



        //String sInitCorr = "1,2,3,4#1,2,1,3,1,4,2,3,2,4,3,4";
        //String corrObject = MyUDFManager.createObj("descstat.corr");

        //String sInitLRCVTrain = "0.01,1,3#1,2,3,4$0.1,0.1,0.1,0.1~0.2,0.2,0.2,0.2~0.3,0.3,0.3,0.3";
        //String sLRObj = MyUDFManager.createObj("learner.lr");

//
////        String sInitString = corrObject+"@"+sInitCorr;
//        initializeInStages(corrObject+"@"+sInitCorr);
//        initializeInStages(sLRObj+"@"+sInitLRCVTrain);
//
//        //MyUDFManager.initializeInStages("STE%"+corrObject+"@"+sInit);
//        MyUDFManager.initObjectList(corrObject+"@"+sLRObj);
//        MyUDFManager.initDecodeIndices("1,2,3,4");
//        for(int i = 0; i < d.length; i ++)
//        {
//            initializeTupleVector(d[i]);
//            MyUDFManager.iterate();
//
//        }
//
//        //String res = MyUDFManager.result(corrObject);
//        String res = getResultInStages(corrObject);
//        System.out.println("Corr: " + res);
//
//        res = getResultInStages(sLRObj);
//        System.out.println("LR : " + res);
//
//        MyUDFManager.deleteObj(corrObject);
//        MyUDFManager.deleteObj(sLRObj);
//
//        MyUDFManager.terminate();
//
//
//





        /**

                byte[] b;
                b = toByteArray(d);

                MyUDFManager.initNumAttributes(Integer.toString(n - 1));
                String aicObj = MyUDFManager.createObj("learner.lr");
                String sInit = "5#1,2,3,4!0.1#5,6,7,8!0.5";
                MyUDFManager.initialize(aicObj+"@"+sInit);
                String bicObj = MyUDFManager.createObj("learner.lr");
                String sInit1 = "5#8,2,5,4!0.1#5,3,7,8!0.7";
                MyUDFManager.initialize(bicObj+"@"+sInit1);

                MyUDFManager.initDecodeIndices("1,2,3,4,5,6,7,8");
                MyUDFManager.initObjectList(aicObj+"@"+bicObj);
                for(int i = 0; i < 10; i ++) {
                    //new Random().nextBytes(b);
                    d = randDoubleArray(n);
                    b = toByteArray(d);
                    MyUDFManager.iterate(b);
                    //MyTuple.print();
                }
                String res = MyUDFManager.result(aicObj);
                MyUDFManager.deleteObj(aicObj);
                MyUDFManager.terminate();
            }
        */
    }

    private static void aicTest(double[][] d, int numFeatures) {
        MyUDFManager.terminate();
        MyUDFManager.initNumAttributes(new Integer(numFeatures-1).toString());
        int[] featureVector = {1,2,3,4};
        String sInit = "1,2,3,4$0.1,0.1,0.1,0.1";
        String sAiCObj = MyUDFManager.createObj("scorer.aic");
        String sInitString = sAiCObj+"@"+sInit;
        initializeInStages(sInitString);
        MyUDFManager.initObjectList(sAiCObj);
        MyUDFManager.initDecodeIndices("1,2,3,4");
        for(int i = 0; i < d.length; i ++)
        {
            initializeTupleVector(d[i]);
            MyUDFManager.iterate();

        }

        //String res = MyUDFManager.result(corrObject);
        String res = getResultInStages(sAiCObj);
        System.out.println(res);
        MyUDFManager.deleteObj(sAiCObj);
        MyUDFManager.terminate();
    }

    private static void testCGTrain(double[][] d, int numFeatures) {
        MyUDFManager.terminate();
        MyUDFManager.initNumAttributes(new Integer(numFeatures-1).toString());
        int[] featureVector = {1,2,3,4};
        String sInit = "3#1,2,3,4$0.1,0.1,0.1,0.1!0.11,0.11,0.11,0.11!0.12,0.12,0.12,0.12~0.2,0.2,0.2,0.2!0.21,0.21,0.21,0.21!" +
                "0.22,0.22,0.22,0.22~0.3,0.3,0.3,0.3!0.31,0.31,0.31,0.31!0.32,0.32,0.32,0.32#2,3,4,5$0.1,0.1,0.1,0.1!0.11,0.11,0.11,0.11!0.12,0.12,0.12,0.12~0.2,0.2,0.2,0.2!0.21,0.21,0.21,0.21!" +
                "0.22,0.22,0.22,0.22~0.3,0.3,0.3,0.3!0.31,0.31,0.31,0.31!0.32,0.32,0.32,0.32";
        String sLRObj = MyUDFManager.createObj("learner.cg");
        String sInitString = sLRObj+"@"+sInit;
        initializeInStages(sInitString);

        //MyUDFManager.initializeInStages("STE%"+corrObject+"@"+sInit);
        MyUDFManager.initObjectList(sLRObj);
        MyUDFManager.initDecodeIndices("1,2,3,4,5");
        for(int i = 0; i < d.length; i ++)
        {
            initializeTupleVector(d[i]);
            MyUDFManager.iterate();

        }

        //String res = MyUDFManager.result(corrObject);
        String res = getResultInStages(sLRObj);
        System.out.println(res);
        MyUDFManager.deleteObj(sLRObj);
        MyUDFManager.terminate();
    }

    private static void testEvaluateLRCV(double[][] d, int numFeatures) {
        MyUDFManager.terminate();
        MyUDFManager.initNumAttributes(new Integer(numFeatures-1).toString());
        int[] featureVector = {1,2,3,4};
        String sInit = "0.01,1,3#1,2,3,4$0.1,0.1,0.1,0.1~0.2,0.2,0.2,0.2~0.3,0.3,0.3,0.3";
        String sLRObj = MyUDFManager.createObj("learner.lr");
        String sInitString = sLRObj+"@"+sInit;
        initializeInStages(sInitString);

        //MyUDFManager.initializeInStages("STE%"+corrObject+"@"+sInit);
        MyUDFManager.initObjectList(sLRObj);
        MyUDFManager.initDecodeIndices("1,2,3,4");
        for(int i = 0; i < d.length; i ++)
        {
            initializeTupleVector(d[i]);
            MyUDFManager.iterate();

        }

        //String res = MyUDFManager.result(corrObject);
        String res = getResultInStages(sLRObj);
        System.out.println(res);
        MyUDFManager.deleteObj(sLRObj);
        MyUDFManager.terminate();

        MyUDFManager.terminate();
        MyUDFManager.initNumAttributes(new Integer(numFeatures-1).toString());
        StringBuilder sb = new StringBuilder("3#");
        sb.append(res);
        sInit = sb.toString();
        sLRObj = MyUDFManager.createObj("scorer.lr");
        sInitString = sLRObj+"@"+sInit;
        initializeInStages(sInitString);
        MyUDFManager.initObjectList(sLRObj);
        MyUDFManager.initDecodeIndices("1,2,3,4");
        for(int i = 0; i < d.length; i ++)
        {
            initializeTupleVector(d[i]);
            MyUDFManager.iterate();

        }

        //String res = MyUDFManager.result(corrObject);
        res = getResultInStages(sLRObj);
        System.out.println(res);
        MyUDFManager.deleteObj(sLRObj);
        MyUDFManager.terminate();
    }

    public static double[] randDoubleArray(int n) {
        double[] res = new double[n];
        Random r = new Random();
        for(int i = 0; i < n; i ++) {
            res[i] = r.nextDouble();
            //System.out.println("d["+i+"] = " + res[i]);
        }
        return res;
    }

    public static byte[] toByteArray(double[] value) {
        byte[] bytes = new byte[8*value.length];
        for(int i = 0; i < value.length; i ++) {
            byte[] b;
            b = toByteArray(value[i]);
            //System.out.println(b.length);
            int shift = i*8;
            for(int j = 0; j < b.length; j++){
                bytes[shift + j] = b[j];
            }
        }
        return bytes;
    }
    public static byte[] toByteArray(double value) {
        byte[] bytes = new byte[8];
        ByteBuffer.wrap(bytes).putDouble(value);
        return bytes;
    }

    public static double toDouble(byte[] bytes) {
        return ByteBuffer.wrap(bytes).getDouble();
    }

}

