public class MyAiCTest extends MyAggregate{
    private MyFeatureSubsetAiC[] objFS;
    public int initialize(String s) {
        // should initialize feature subsets and the coef values.
        // schema fs1#fs2#fs3
        String []splitted = s.split("#");
	//SimpleLogger.write("(init) Inp String : " + s);
        objFS = new MyFeatureSubsetAiC[splitted.length - 1];
        for(int i = 1; i < splitted.length; i ++) {
            objFS[i-1] = new MyFeatureSubsetAiC();
            objFS[i-1].initFeatureSubset(splitted[i]); // hardcoding the number of folds to 1.
        }
        return 1;
    }
    public int iterate() {
        for(int i = 0; i < objFS.length; i ++) {
            int numFeatures = objFS[i].featureIndices.length;
            double wx = 0.0;
            for(int j = 0; j < numFeatures; j ++ ) {
                int featureIndex = objFS[i].featureIndices[j];
                double wVal = objFS[i].coefficients[j]; //fold is hardcoded
                double x = MyTuple.xVal[featureIndex];
                wx += wVal*x;
            }
            double yVal = MyTuple.yVal > 0.5 ? 1 : -1;
            double v = wx*yVal;
            double lkhood = Math.log(1+Math.exp(-1*v)); // should be modified
            objFS[i].likelihood += lkhood;
        }
        return 1;
    }
    public String result() {
        // layout : fs1#fs2#fs3...#fsn
        // fs1 : featuresetIndices $ fold1 ~ fold2 ~ .. foldn
        // fold"k" = cv
        StringBuilder sb = new StringBuilder();
        String res;
        for(int i = 0; i < objFS.length; i ++)
        {
            res = objFS[i].getAiCScore();
            sb.append(res);
            if(i != objFS.length - 1)
            {
                sb.append("#");
            }

        }
        return sb.toString();

    }
    public int terminate() {
        objFS = null;
        return 1;
    }



}
